package cc.smtweb.system.bpm.web.engine.model.flow.listcard.lcms;

import cc.smtweb.framework.core.annotation.SwBody;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.mvc.service.AbstractHandler;
import cc.smtweb.framework.core.session.UserSession;
import cc.smtweb.system.bpm.web.engine.model.common.FlowModelService;
import cc.smtweb.system.bpm.web.engine.model.listcard.lcms.LCMsService;

/**
 * @Author:lip
 * @Date : 2022/9/16 18:53
 * 模型：FLOW_LT_MS 服务类
 */
@SwService
public class FlowLcMsService extends FlowModelService {
    private LCMsService worker = new LCMsService();

    protected AbstractHandler createHandler(String type) {
        switch (type) {
            case TYPE_MODEL_LIST:
            case TYPE_MODEL_LOAD:
                return super.createHandler(type);
            case TYPE_MODEL_SAVE:
                return new FlowLcMsSaveHandler();
            case TYPE_MODEL_DEL:
                return new FlowLcMsDelHandler();
        }
        return worker.createHandler(type);
    }

    /**
     * 子表单独保存
     * @param params
     * @param us
     * @return
     */
    public R modelSubSave(@SwBody SwMap params, UserSession us) {
        return worker.modelSubSave(params,us);
    }

    /**
     * 子表编辑
     * @param params
     * @param us
     * @return
     */
    public R modelSubLoad(@SwBody SwMap params, UserSession us) {
        return worker.modelSubLoad(params,us);
    }

    /**
     * 子表新增初始化
     * @param params
     * @param us
     * @return
     */
    public R modelSubAdd(@SwBody SwMap params, UserSession us) {
        return worker.modelSubAdd(params,us);
    }

    /**
     * 子表单独删除
     * @param params
     * @param us
     * @return
     */
    public R modelSubDel(@SwBody SwMap params, UserSession us) {
        return worker.modelSubDel(params,us);
    }

    /**
     * 子表列表数据
     * @param params
     * @param us
     * @return
     */
    public R modelSubList(@SwBody SwMap params, UserSession us) {
        return worker.modelSubList(params,us);
    }

    /**
     * 列子表表总记录数及合计栏
     * @param params
     * @param us
     * @return
     */
    public R modelSubListTotal(@SwBody SwMap params, UserSession us) {
        return worker.modelSubListTotal(params,us);
    }
}
